/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the MessageRequestLocation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageRequestLocation{}

// MessageRequestLocation struct for MessageRequestLocation
type MessageRequestLocation struct {
	ButtonLabelId *string `json:"button_label_id,omitempty"`
}

// NewMessageRequestLocation instantiates a new MessageRequestLocation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageRequestLocation() *MessageRequestLocation {
	this := MessageRequestLocation{}
	return &this
}

// NewMessageRequestLocationWithDefaults instantiates a new MessageRequestLocation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageRequestLocationWithDefaults() *MessageRequestLocation {
	this := MessageRequestLocation{}
	return &this
}

// GetButtonLabelId returns the ButtonLabelId field value if set, zero value otherwise.
func (o *MessageRequestLocation) GetButtonLabelId() string {
	if o == nil || IsNil(o.ButtonLabelId) {
		var ret string
		return ret
	}
	return *o.ButtonLabelId
}

// GetButtonLabelIdOk returns a tuple with the ButtonLabelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageRequestLocation) GetButtonLabelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ButtonLabelId) {
		return nil, false
	}
	return o.ButtonLabelId, true
}

// HasButtonLabelId returns a boolean if a field has been set.
func (o *MessageRequestLocation) HasButtonLabelId() bool {
	if o != nil && !IsNil(o.ButtonLabelId) {
		return true
	}

	return false
}

// SetButtonLabelId gets a reference to the given string and assigns it to the ButtonLabelId field.
func (o *MessageRequestLocation) SetButtonLabelId(v string) {
	o.ButtonLabelId = &v
}

func (o MessageRequestLocation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageRequestLocation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ButtonLabelId) {
		toSerialize["button_label_id"] = o.ButtonLabelId
	}
	return toSerialize, nil
}

type NullableMessageRequestLocation struct {
	value *MessageRequestLocation
	isSet bool
}

func (v NullableMessageRequestLocation) Get() *MessageRequestLocation {
	return v.value
}

func (v *NullableMessageRequestLocation) Set(val *MessageRequestLocation) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageRequestLocation) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageRequestLocation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageRequestLocation(val *MessageRequestLocation) *NullableMessageRequestLocation {
	return &NullableMessageRequestLocation{value: val, isSet: true}
}

func (v NullableMessageRequestLocation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageRequestLocation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


